// -------------------------------------------------------------------------------
// 
// 		cwCu		nhǗvO
// 
// 				Ver 3.15e
// 
// -------------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ------------------------------------------------------------------
#include "DxHandle.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxASyncLoad.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxLog.h"

#ifndef DX_NON_ASYNCLOAD
#include "DxGraphics.h"
#include "DxSoftImage.h"
#include "DxSound.h"
#include "DxMask.h"
#include "DxNetwork.h"
#include "DxModel.h"
#include "DxFile.h"
#include "DxFont.h"
#endif // DX_NON_ASYNCLOAD

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

HANDLEMANAGE HandleManageArray[ DX_HANDLETYPE_MAX ] ;

// ֐vg^Cv錾-----------------------------------------------------------

// vO --------------------------------------------------------------------


// nhʊ֌W

// nhǗ
// ( InitializeFlag ɂ FALSE ĂKv )
extern int InitializeHandleManage(
	int HandleType,
	int OneSize,
	int MaxNum,
	int ( *InitializeFunction )( HANDLEINFO *HandleInfo ),
	int ( *TerminateFunction )( HANDLEINFO *HandleInfo ),
	const wchar_t *Name
)
{
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	// ɏĂ牽Ȃ
	if( HandleManage->InitializeFlag )
		return -1 ;

	// NextIDȊO[
	int NextID = HandleManage->NextID ;
	_MEMSET( HandleManage, 0, sizeof( *HandleManage ) ) ;
	HandleManage->NextID = NextID ;

	// p[^Zbg
	HandleManage->HandleTypeMask = HandleType << DX_HANDLETYPE_ADDRESS ;
	HandleManage->OneSize = OneSize ;
	HandleManage->MaxNum = MaxNum ;
	HandleManage->InitializeFunction = InitializeFunction ;
	HandleManage->TerminateFunction = TerminateFunction ;
	HandleManage->Name = Name ;
	ConvString( ( const char * )HandleManage->Name, WCHAR_T_CHARCODEFORMAT, HandleManage->NameUTF16LE, DX_CHARCODEFORMAT_UTF16LE ) ;

	// nh̃f[^|C^AhXi[郁AhXz̊m
	HandleManage->Handle = ( HANDLEINFO ** )DXCALLOC( sizeof( HANDLEINFO * ) * MaxNum ) ;
	if( HandleManage->Handle == NULL )
		return -1 ;

	// nhXg̏
	InitializeHandleList( &HandleManage->ListFirst, &HandleManage->ListLast ) ;

	// NeBJZNV̏
	CriticalSection_Initialize( &HandleManage->CriticalSection ) ;

	// tO𗧂Ă
	HandleManage->InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// nhǗ̌ns
extern int TerminateHandleManage( int HandleType )
{
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	// ɌnĂ牽Ȃ
	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

	// ׂẴnh폜
	AllHandleSub( HandleType ) ;

	// nh|C^i[p̃AhXz
	if( HandleManage->Handle != NULL )
	{
		DXFREE( HandleManage->Handle ) ;
		HandleManage->Handle = NULL ;
	}

	// NeBJZNV̍폜
	CriticalSection_Delete( &HandleManage->CriticalSection ) ;

	// NextIDȊO[
	int NextID = HandleManage->NextID ;
	_MEMSET( HandleManage, 0, sizeof( *HandleManage ) ) ;
	HandleManage->NextID = NextID ;

	// tO|
	HandleManage->InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// nhǉ
extern int AddHandle( int HandleType, int ASyncThread, int Handle )
{
	int NextIndex ;
	int NewHandle ;
	HANDLEINFO **ppHandleInfo ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// ǉłȂꍇ͏I
	if( HandleManage->Num == HandleManage->MaxNum )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		DXST_ERRORLOGFMT_ADDUTF16LE(( "\x25\x00\x73\x00\xcf\x30\xf3\x30\xc9\x30\xeb\x30\x6e\x30\x70\x65\x4c\x30\x50\x96\x4c\x75\x70\x65\x28\x00\x20\x00\x25\x00\x64\x00\x20\x00\x29\x00\x6b\x30\x54\x90\x57\x30\x66\x30\x44\x30\x66\x30\xb0\x65\x5f\x30\x6a\x30\xcf\x30\xf3\x30\xc9\x30\xeb\x30\x92\x30\x5c\x4f\x10\x62\x67\x30\x4d\x30\x7e\x30\x5b\x30\x93\x30\x00"/*@ L"%snh̐E( %d )ɒBĂĐVȃnh쐬ł܂" @*/, HandleManage->NameUTF16LE, HandleManage->MaxNum )) ;
		return -1 ;
	}

	// 󂫔zԍ̌
	if( Handle != -1 && HandleManage->Handle[ Handle & DX_HANDLEINDEX_MASK ] == NULL )
	{
		NextIndex = Handle & DX_HANDLEINDEX_MASK ;
		ppHandleInfo = &HandleManage->Handle[ NextIndex ] ;
	}
	else
	{
		if( HandleManage->Num == 0 )
		{
			NextIndex = 0 ;
			ppHandleInfo = &HandleManage->Handle[ NextIndex ] ;
		}
		else
		{
			if( HandleManage->AreaMax + 1 < HandleManage->MaxNum )
			{
				NextIndex = HandleManage->AreaMax + 1 ;
				ppHandleInfo = &HandleManage->Handle[ NextIndex ] ;
			}
			else
			if( HandleManage->AreaMin - 1 > 0 )
			{
				NextIndex = HandleManage->AreaMin - 1 ;
				ppHandleInfo = &HandleManage->Handle[ NextIndex ] ;
			}
			else
			{
				ppHandleInfo = HandleManage->Handle ;
				for( NextIndex = 0 ; *ppHandleInfo != NULL ; NextIndex ++, ppHandleInfo ++ ){}
			}
		}
	}

	// f[^̈mۂ
	*ppHandleInfo = ( HANDLEINFO * )DXCALLOC( ( size_t )HandleManage->OneSize ) ;
	if( *ppHandleInfo == NULL )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		DXST_ERRORLOGFMT_ADDUTF16LE(( "\x25\x00\x73\x00\xcf\x30\xf3\x30\xc9\x30\xeb\x30\x6e\x30\xc7\x30\xfc\x30\xbf\x30\x92\x30\x3c\x68\x0d\x7d\x59\x30\x8b\x30\xe1\x30\xe2\x30\xea\x30\x18\x98\xdf\x57\x6e\x30\xba\x78\xdd\x4f\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"%snh̃f[^i[郁̈̊mۂɎs܂" @*/, HandleManage->NameUTF16LE )) ;
		return -1 ;
	}

	// G[`FbNphc̐ݒ
	if( Handle != -1 )
	{
		(*ppHandleInfo)->ID = ( Handle & DX_HANDLECHECK_MASK ) >> DX_HANDLECHECK_ADDRESS ;
	}
	else
	{
		HandleManage->NextID ++ ;
		if( HandleManage->NextID >= ( DX_HANDLECHECK_MASK >> DX_HANDLECHECK_ADDRESS ) )
			HandleManage->NextID = 0 ;

		(*ppHandleInfo)->ID = HandleManage->NextID ;
	}

	// ̊mۃTCYۑ
	( *ppHandleInfo )->AllocSize = HandleManage->OneSize ;

#ifndef DX_NON_ASYNCLOAD
	// 񓯊XbhĂ΂ꂽꍇ͔񓯊ǂݍ݃JEgPɂ
	if( ASyncThread )
	{
		( *ppHandleInfo )->ASyncLoadCount  = 1 ;
		( *ppHandleInfo )->ASyncDataNumber = -1 ;
	}
#endif // DX_NON_ASYNCLOAD

	// nhlۑ
	NewHandle = (*ppHandleInfo)->Handle = NextIndex | HandleManage->HandleTypeMask | ( (*ppHandleInfo)->ID << DX_HANDLECHECK_ADDRESS ) ;

	// nh̐𑝂₷
	HandleManage->Num ++ ;

	// gpĂnh݂͈͂XV
	if( HandleManage->Num == 1 )
	{
		HandleManage->AreaMax = NextIndex ;
		HandleManage->AreaMin = NextIndex ;
	}
	else
	{
		if( HandleManage->AreaMax < NextIndex ) HandleManage->AreaMax = NextIndex ;
		if( HandleManage->AreaMin > NextIndex ) HandleManage->AreaMin = NextIndex ;
	}

	// Xg֗vfǉ
	AddHandleList( &HandleManage->ListFirst, &(*ppHandleInfo)->List, (*ppHandleInfo)->Handle, *ppHandleInfo ) ;

	// ֐Ă
	if( HandleManage->InitializeFunction )
	{
		HandleManage->InitializeFunction( *ppHandleInfo ) ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// nhԂ
	return NewHandle ;
}

// nh폜
extern int SubHandle( int Handle )
{
	HANDLEINFO *HandleInfo ;
	int Index ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	Index = Handle & DX_HANDLEINDEX_MASK ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return -1 ;
	}

#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍݒłꍇł܂ĂȂ珈LZ
	if( HandleInfo->ASyncLoadCount != 0 )
	{
		if( HandleInfo->ASyncDataNumber < 0 ||
			DeleteASyncLoadData( HandleInfo->ASyncDataNumber, TRUE ) < -1 )
		{
			// NeBJZNV̉
			CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

			// 폜ɎsǂݍݏI܂ő҂
			while( HandleInfo->ASyncLoadCount != 0 )
			{
				ProcessASyncLoadRequestMainThread() ;
				Thread_Sleep( 0 );
			}

			// NeBJZNV̎擾
			CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;
		}
	}
#endif // DX_NON_ASYNCLOAD

	// nh^CvX̌n
	if( HandleManage->TerminateFunction )
	{
		// ߂lP̏ꍇ͍폜LZ
		if( HandleManage->TerminateFunction( HandleInfo ) == 1 )
			goto END ;
	}

	// 폜tO-1
	if( HandleInfo->DeleteFlag != NULL )
	{
		*HandleInfo->DeleteFlag = -1 ;
	}

	// XgvfO
	SubHandleList( &HandleInfo->List ) ;

	// f[^̈
	DXFREE( HandleInfo ) ;

	// e[u NULL Zbg
	HandleManage->Handle[ Index ] = NULL ;

	// nh̑炷
	HandleManage->Num -- ;

	// Lȃnh݂͈͂̍XV
	if( HandleManage->Num == 0 )
	{
		HandleManage->AreaMax = 0 ;
		HandleManage->AreaMin = 0 ;
	}
	else
	{
		if( Index == HandleManage->AreaMax )
		{
			while( HandleManage->Handle[ HandleManage->AreaMax ] == NULL )
				HandleManage->AreaMax -- ; 
		}
		else
		if( Index == HandleManage->AreaMin )
		{
			while( HandleManage->Handle[ HandleManage->AreaMin ] == NULL )
				HandleManage->AreaMin ++ ; 
		}
	}

END :

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return 0 ;
}

// nh̏i[郁̈̃TCYύXA񓯊ǂݍݒłȂƂO
extern int ReallocHandle( int Handle, size_t NewSize )
{
	HANDLEINFO *HandleInfo ;
	int Index ;
	void *NewBuffer ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	Index = Handle & DX_HANDLEINDEX_MASK ;

	// mۃ̃TCYωȂꍇ͉I
	if( ( size_t )HandleInfo->AllocSize == NewSize )
		return 0 ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// ̍Ċm
	NewBuffer = ( HANDLEINFO * )DXREALLOC( HandleInfo, ( size_t )NewSize ) ;

	// ̍Ċmې`FbN
	if( NewBuffer == NULL )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		// G[I
		return -1 ;
	}

	// mۃAhXωꍇ̓XĝȂ
	if( NewBuffer != ( void * )HandleInfo )
	{
		// VAhXZbg
		HandleInfo = HandleManage->Handle[ Index ] = ( HANDLEINFO * )NewBuffer ;

		// Xǧq
		NewMemoryHandleList( &HandleInfo->List, HandleInfo ) ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return 0 ;
}

// nh̏擾
extern HANDLEINFO *GetHandleInfo( int Handle )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return NULL ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return NULL ;

	// nh̏Ԃ
	return HandleInfo ;
}

// nhǗɓo^Ă邷ׂẴnh폜
extern int AllHandleSub( int HandleType, int (*DeleteCancelCheckFunction)( HANDLEINFO *HandleInfo ) )
{
	int i ;
	HANDLEINFO **ppHandleInfo ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

//	// NeBJZNV̎擾
//	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;
//
//#ifndef DX_NON_ASYNCLOAD
//	// 񓯊ǂݍ݈˗폜Ă
//	ppHandleInfo = &HandleManage->Handle[ HandleManage->AreaMin ] ;
//	for( i = HandleManage->AreaMin ; i <= HandleManage->AreaMax ; i ++, ppHandleInfo ++ )
//	{
//		if( *ppHandleInfo )
//		{
//			if( DeleteCancelCheckFunction == NULL ||
//				DeleteCancelCheckFunction( *ppHandleInfo ) == FALSE )
//			{
//				if( (*ppHandleInfo)->ASyncLoadCount != 0 )
//				{
//					if( DeleteASyncLoadData( (*ppHandleInfo)->ASyncDataNumber, TRUE ) >= -1 )
//					{
//						(*ppHandleInfo)->ASyncLoadCount = 0 ;
//					}
//				}
//			}
//		}
//	}
//#endif // DX_NON_ASYNCLOAD
//
//	// NeBJZNV̉
//	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// ׂẴnhf[^폜
	{
		int AreaMin ;
		int AreaMax ;
		int Handle ;
		int DeleteFlag ;
		int LoopFlag ;

		// NeBJZNV̎擾
		CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

		do
		{
			LoopFlag = FALSE ;

			AreaMin = HandleManage->AreaMin ;
			AreaMax = HandleManage->AreaMax ;

			ppHandleInfo = &HandleManage->Handle[ AreaMin ] ;
			for( i = AreaMin ; i <= AreaMax ; i ++, ppHandleInfo ++ )
			{
				if( *ppHandleInfo == NULL )
				{
					continue ;
				}

				if( DeleteCancelCheckFunction != NULL )
				{
					DeleteFlag = DeleteCancelCheckFunction( *ppHandleInfo ) == FALSE ? TRUE : FALSE ;
				}
				else
				{
					DeleteFlag = TRUE ;
				}

				if( DeleteFlag )
				{
					Handle = (*ppHandleInfo)->Handle ;

					// NeBJZNV̉
					CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

					SubHandle( Handle ) ;

					// NeBJZNV̎擾
					CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

					LoopFlag = TRUE ;
					break ;
				}
			}

		}while( LoopFlag == TRUE ) ;

		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;
	}

	// I
	return 0 ;
}









#ifndef DX_NON_ASYNCLOAD

// 񓯊ǂݍ݊֌W

// nh̔񓯊ǂݍ݂Ă邩ǂ擾( TRUE:Ă  FALSE:܂ĂȂ  -1:G[ )
extern int NS_CheckHandleASyncLoad( int Handle )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	return HandleInfo->ASyncLoadCount != 0 ? TRUE : FALSE ;
}

// nh̔񓯊ǂݍݏ̖߂l擾( 񓯊ǂݍݒ̏ꍇ͈O̔񓯊ǂݍݏ̖߂lԂĂ܂ )
extern int NS_GetHandleASyncLoadResult( int Handle )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	return HandleInfo->ASyncLoadResult ;
}

// nh̔񓯊ǂݍݒJEgCNg
extern int IncASyncLoadCount( int Handle, int ASyncDataNumber )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	HandleInfo->ASyncLoadCount ++ ;
	HandleInfo->ASyncDataNumber = ASyncDataNumber ;

	// I
	return 0 ;
}

// nh̔񓯊ǂݍݒJEgfNg
extern int DecASyncLoadCount( int Handle )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	HandleInfo->ASyncLoadCount -- ;

	// I
	return 0 ;
}

// nh񓯊ǂݍݒꍇA񓯊ǂݍ݂܂ő҂
extern int WaitASyncLoad( int Handle )
{
#ifndef DX_NON_ASYNCLOAD
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;
	HANDLEMANAGE *HandleManage = &HandleManageArray[ HandleType ] ;

	if( HandleManage->InitializeFlag == FALSE )
		return -1 ;

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		return -1 ;
	}

	// 񓯊ǂݍݒłꍇ͏܂ő҂
	if( HandleInfo->ASyncLoadCount != 0 )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

		// I҂
		while( HandleInfo->ASyncLoadCount != 0 )
		{
			ProcessASyncLoadRequestMainThread() ;
			Thread_Sleep( 0 );
		}

		// NeBJZNV̎擾
		CRITICALSECTION_LOCK( &HandleManage->CriticalSection ) ;
	}

	// NeBJZNV̉
	CriticalSection_Unlock( &HandleManage->CriticalSection ) ;

	// I
	return 0 ;
#else // DX_NON_ASYNCLOAD

	// I
	return 0 ;
#endif // DX_NON_ASYNCLOAD
}

#endif // DX_NON_ASYNCLOAD









// nhXg

// Xg̏
extern int InitializeHandleList( HANDLELIST *First, HANDLELIST *Last )
{
	First->Handle = -1 ;
	First->Data   = NULL ;
	First->Prev   = NULL ;
	First->Next   = Last ;
	Last->Handle  = -1 ;
	Last->Data    = NULL ;
	Last->Prev    = First ;
	Last->Next    = NULL ;

	// I
	return 0 ;
}

// Xg֗vfǉ
extern int AddHandleList( HANDLELIST *First, HANDLELIST *List, int Handle, void *Data )
{
	List->Handle      = Handle ;
	List->Data        = Data ;
	List->Prev        = First ;
	List->Next        = First->Next ;
	First->Next->Prev = List ;
	First->Next       = List ;

	// I
	return 0 ;
}

// XgvfO
extern int SubHandleList( HANDLELIST *List )
{
	List->Prev->Next = List->Next ;
	List->Next->Prev = List->Prev ;

	return 0 ;
}

// Xg݂郁ύXꂽꍇɃXg̑OXV
extern int NewMemoryHandleList( HANDLELIST *List, void *Data )
{
	List->Data = Data ;

	List->Prev->Next = List ;
	List->Next->Prev = List ;

	// I
	return 0 ;
}







// nh폜ꂽƂɁ|Pݒ肳ϐo^
extern int NS_SetDeleteHandleFlag( int Handle, int *DeleteFlag )
{
	HANDLEINFO *HandleInfo ;
	int HandleType = ( int )( ( ( DWORD )Handle & DX_HANDLETYPE_MASK ) >> DX_HANDLETYPE_ADDRESS ) ;

	// G[
	if( HANDLECHK_ASYNC( HandleType, Handle, HandleInfo ) )
		return -1 ;

	HandleInfo->DeleteFlag = DeleteFlag  ;

	// I
	return 0 ;
}







#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE
