// -------------------------------------------------------------------------------
// 
// 		cwCu		OvOwb_t@C
// 
// 				Ver 3.15e
// 
// -------------------------------------------------------------------------------

#ifndef __DXLOG_H__
#define __DXLOG_H__

// CN[h ------------------------------------------------------------------

#include "DxCompileConfig.h"
#include "DxFile.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

//cwCũeɗ͌炷ǂ̒`𔽉fׂ̃}N
#if !defined( DX_NON_LITERAL_STRING ) && !defined( DX_NON_LOG )
	#define DXSTRING( x )					x
	#define DXST_ERRORLOG_ADD(x)			NS_ErrorLogAdd(x)
	#define DXST_ERRORLOG_ADDA(x)			ErrorLogAddA(x)
	#define DXST_ERRORLOG_ADDW(x)			ErrorLogAddW(x)
	#define DXST_ERRORLOG_ADDUTF16LE(x)		ErrorLogAddUTF16LE(x)
	#define DXST_ERRORLOGFMT_ADD(x)			NS_ErrorLogFmtAdd x
	#define DXST_ERRORLOGFMT_ADDA(x)		ErrorLogFmtAddA x
	#define DXST_ERRORLOGFMT_ADDW(x)		ErrorLogFmtAddW x
	#define DXST_ERRORLOGFMT_ADDUTF16LE(x)	ErrorLogFmtAddUTF16LE x
	#define DXST_ERRORLOG_TABADD			NS_ErrorLogTabAdd()
	#define DXST_ERRORLOG_TABSUB			NS_ErrorLogTabSub()
	#define DXERRORNETLOG_ADD(x)			ErrorNetLogAdd(x)
	#define DXERRORNETWORK(x)				ErrorNetWork x
#else
	#define DXSTRING( x )					" "
	#define DXST_ERRORLOG_ADD(x)			(-1)
	#define DXST_ERRORLOG_ADDA(x)			(-1)
	#define DXST_ERRORLOG_ADDW(x)			(-1)
	#define DXST_ERRORLOG_ADDUTF16LE(x)		(-1)
	#define DXST_ERRORLOGFMT_ADD(x)			(-1)
	#define DXST_ERRORLOGFMT_ADDA(x)		(-1)
	#define DXST_ERRORLOGFMT_ADDW(x)		(-1)
	#define DXST_ERRORLOGFMT_ADDUTF16LE(x)	(-1)
	#define DXST_ERRORLOG_TABADD			(0)
	#define DXST_ERRORLOG_TABSUB			(0)
	#define DXERRORNETLOG_ADD(x)			(-1)
	#define DXERRORNETWORK(x)				(-1)
#endif


#ifndef DX_NON_LOG

#define LOG_MAXHEIGHT				(80)				// Pʂɓ郍O̍ős
#define LOG_MAXLENGTH				(255)				// Ps̃OɎg镶̒

// Op`
#define LOG_FONTSIZE				(16)				// OɎgtHg̃TCY
#define LOG_FONTTICK				(4)					// O\ɎgtHg̑
#define LOG_TABWIDTH				(4)					// ^u̕

// \̒` --------------------------------------------------------------------

// Of[^\
struct LOGDATA
{
	int						InitializeFlag ;					// tO

	int						NonUseTimeStampFlag ;				// ^CX^vo͂Ȃǂ̃tO
	int						NotLogOutFlag ;						// Oo͂stO(TRUEōsȂ)
	int						LogStartTime ;						// Ñ^CX^v
	wchar_t					LogOutDirectory[ FILEPATH_MAX ] ;	// Oo͂st@CۑfBNg
	int						UseLogDateName ;					// Oo͂st@Cɓt邩ǂ̃tO
	wchar_t					LogFileName[256] ;					// Oo͂st@C̖O
	int						ErTabNum ;							// G[Orõ^u̐
	int						ErTabStop ;							// ^uroXgbvtO

#ifndef DX_NON_PRINTF_DX
	int						LogInitializeFlag ;					// Of[^Ă邩tO
	int						LogFontHandle ;						// O`ptHgnh
	int						LogFontHandleLostFlag ;				// tHgnh폜ꂽۂɗtO
	int						LogX ,LogY ;						// ݂̃ÕJ[\ʒu
	wchar_t					LogString[LOG_MAXHEIGHT][LOG_MAXLENGTH] ; // O
	int						LogDrawFlag ;						// Oʏɕ\邩AtO
	int						LogFontSize ;						// OtHg̃TCY
	int						LogTabWidth ;						// Õ^u̕
	int						LogDrawWidth ;						// ݃J[\s̕`敝
	int						LogFileOutFlag ;					// Ot@Co͂邩AtO
#endif // DX_NON_PRINTF_DX

} ;

// ϐ錾 --------------------------------------------------------------

extern LOGDATA LogData ;

// ֐vg^Cv錾-----------------------------------------------------------

// Oo͋@\֐
extern	int			ErrorLogInitialize(		void ) ;										// G[ot@C
extern	int			ErrorLogTerminate(		void ) ;										// G[ot@Čn
extern	int			ErrorLogAddA(			const char    *ErrorStr ) ;						// G[o( char )
extern	int			ErrorLogAddW(			const wchar_t *ErrorStr ) ;						// G[o( wchar_t )
extern	int			ErrorLogAddUTF16LE(		const char    *ErrorStr ) ;						// G[o( UTF16LE )
extern 	int			ErrorLogFmtAddA(		const char	  *FormatString , ... ) ;			// tG[o( char )
extern 	int			ErrorLogFmtAddW(		const wchar_t *FormatString , ... ) ;			// tG[o( wchar_t )
extern 	int			ErrorLogFmtAddUTF16LE(	const char    *FormatString , ... ) ;			// tG[o( UTF16LE )

// wchar_tŊ֐
extern	int			ErrorLogAdd_WCHAR_T(	const wchar_t *ErrorStr ) ;						// Ot@C( Log.txt ) ɕo͂
extern 	int			ErrorLogFmtAdd_WCHAR_T(	const wchar_t *FormatString , ... ) ;			// t Ot@C( Log.txt ) ɕo͂(  printf Ɠ )
extern 	int			AppLogAdd_WCHAR_T(		const wchar_t *String , ... ) ;					// ErrorLogFmtAdd Ɠ@\̊֐

extern	int			SetApplicationLogSaveDirectory_WCHAR_T(	const wchar_t *DirectoryPath );	// Ot@C( Log.txt ) ۑfBNgpXݒ肷


// ˑ֐
extern	int			ErrorLogInitialize_PF( const wchar_t *LogFilePath ) ;					// G[ot@C鏈̊ˑ
extern	int			ErrorLogAdd_WCHAR_T_PF( const wchar_t *LogFilePath, const wchar_t *ErrorStr ) ;	// G[o̊ˑ



#ifndef DX_NON_PRINTF_DX

extern	int			IsInitializeLog( void ) ;												// O@\̏sǂ擾
extern	int			InitializeLog( void ) ;													// O@\̏
extern	int			TerminateLog( void ) ;													// Ǒns
extern	int			DrawLog( void ) ;														// O`悷

// wchar_tŊ֐
extern 	int			printfDx_WCHAR_T(		 const wchar_t *FormatString , ... ) ;				// printf Ɠŉʂɕ\邽߂̊֐

#endif // DX_NON_PRINTF_DX

#endif // DX_NON_LOG

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // __DXLOG_H__

